'*******************************************************************************
'* SMS Type Editor. (Compatible with AMC8)                                     *
'* Compiler: BASCOM-AVR 2.0.5.0                                                *
'* Creation Date: 20.July.2011                                                 *
'* Last - Change: no change yet                                                *
'* Author: Behnam Zakizadeh                                                    *
'* License: freeware                                                           *
'* www.avr64.com                                                               *
'* Ver: 1.0                                                                    *
'*******************************************************************************

$regfile = "m8def.dat"
$crystal = 1000000
$framesize = 128
$hwstack = 128
$swstack = 128
$projecttime = 98

'Globals
Dim Position As Byte , Index As Byte , Tmr As Byte , Capslock As Bit
Dim _num As String * 5 , Old_num As String * 5

'Int
Enable Interrupts

'Timer
Config Timer0 = Timer , Prescale = 64
On Ovf0 Timeout0
Enable Ovf0
Stop Timer0

'LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = _
 Portc.5 , E = Portc.1 , Rs = Portc.0
Config Lcd = 16 * 2

'Keypad
Config Kbd = Portd

'Sub's
Declare Sub Main()
Declare Sub _system_call_1()

'Backlight
Config Pinb.2 = Output : Backlight Alias Portb.2

'Speaker
Config Pinb.6 = Output : Speaker Alias Portb.6

'Main Prog Start Here:
Do
   Call Main()
Loop
End
'_______________________________________________________________________________

Sub Main()
   Sound Speaker , 240 , 50
   Cls : Cursor Off Blink
   Position = 1
   Local _key As Byte , _ch As String * 1
   Index = 0
   Old_num = ""
   Cls
   Do
      _key = Getkbd()
      _num = Lookupstr(_key , Keypad)
      If _num = "F2" Then
         Toggle Backlight
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "1" Then
         Call _system_call_1()
         _ch = Lookupstr(index , sms1)
         Locate 1 , Position
         Lcd _ch
         Incr Index
         If Index > 12 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "2" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms2)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 3 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "3" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms3)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 3 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "4" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms4)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 3 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "5" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms5)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 3 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "6" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms6)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 3 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "7" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms7)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 4 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "8" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms8)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 3 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "9" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms9)
         Locate 1 , Position
         If Capslock = 1 Then _ch = Ucase(_ch)
         Lcd _ch
         Incr Index
         If Index > 4 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "0" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms0)
         Locate 1 , Position
         Lcd _ch
         Incr Index
         If Index > 1 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "#" Then
         Call _system_call_1()
         _ch = Lookupstr(index , Sms_sh)
         Locate 1 , Position
         Lcd _ch
         Incr Index
         If Index > 1 Then Index = 0
         Sound Speaker , 120 , 20
         Waitms 200
      End If
      If _num = "Esc" Then
         If Tmr > 0 Then
            Stop Timer0
            Tmr = 0
            Incr Position
         End If
         If Position > 1 Then Decr Position
         Locate 1 , Position
         Lcd " "
         Locate 1 , Position
         Sound Speaker , 120 , 20
         Waitms 200
         Sound Speaker , 120 , 80
      End If
      If _num = "*" Then
         Toggle Capslock
         Sound Speaker , 120 , 20
         Waitms 200
      End If
   Loop
End Sub
'_______________________________________________________________________________

'Keypad Decode Data Table
Keypad:
Data "1" , "2" , "3" , "Esc"
Data "4" , "5" , "6" , "F2"
Data "7" , "8" , "9" , "F3"
Data "*" , "0" , "#" , "Enter" , "no"
'_______________________________________________________________________________

'SMS
Sms1:
Data "." , "," , "-" , "?" , "!" , "'" , "@" , ":" , ";" , "/" , "(" , ")" , "1"
Sms2:
Data "a" , "b" , "c" , "2"
Sms3:
Data "d" , "e" , "f" , "3"
Sms4:
Data "g" , "h" , "i" , "4"
Sms5:
Data "j" , "k" , "l" , "5"
Sms6:
Data "m" , "n" , "o" , "6"
Sms7:
Data "p" , "q" , "r" , "s" , "7"
Sms8:
Data "t" , "u" , "v" , "8"
Sms9:
Data "w" , "x" , "y" , "z" , "9"
Sms0:
Data "+" , "0"
Sms_sh:
Data " " , "#"
'_______________________________________________________________________________

Timeout0:
Incr Tmr
If Tmr > 30 Then
   Stop Timer0
   Tmr = 0
   Sound Speaker , 120 , 80
   Index = 0
   Incr Position
   Locate 1 , Position
End If
Return
'_______________________________________________________________________________
Sub _system_call_1()
   If Tmr > 0 And Old_num <> _num Then
      Stop Timer0
      Tmr = 0
      Incr Position
   End If
   Old_num = _num
   Start Timer0
   Tmr = 0
End Sub



'end of file